#!/usr/bin/python3
import base64, sys
try:
    from Cryptodome.PublicKey import RSA
    from Cryptodome.Cipher import Blowfish
    from Cryptodome.Util.number import bytes_to_long, long_to_bytes
except ImportError:
    from Crypto.PublicKey import RSA
    from Crypto.Cipher import Blowfish
    from Crypto.Util.number import bytes_to_long, long_to_bytes

fd = open(sys.argv[1], "rb")
key = RSA.importKey(open(sys.argv[2]).read())

while fd.readline() != b"%%% protect key_block\r\n":
    pass

key_block = fd.readline()
key_block = key._decrypt(bytes_to_long(base64.b64decode(key_block)))
key_block = dict(l.split(b"=",1) for l in long_to_bytes(key_block).rsplit(b"\x00")[1].split(b"\r\n") if l)

bf = Blowfish.new(key_block[b'data_decrypt_key'], Blowfish.MODE_ECB)

while fd.readline() != b"%%% protect data_block\r\n":
    pass

data_block = fd.readline()
data_block = base64.b64decode(data_block)

print(bf.decrypt(data_block).decode("utf8"))
